﻿Shader "Hidden/Pixelate"
{
	Properties
	{
		_MainTex ("Texture", 2D) = "white" {}
		_MainTexTarget ("Texture Target", Vector) = (0,0,0,0) 
	}
	SubShader
	{
		// No culling or depth
		Cull Off ZWrite Off ZTest Always

		Pass
		{
			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag
			
			#include "UnityCG.cginc"

			struct appdata
			{
				float4 vertex : POSITION;
				float2 uv : TEXCOORD0;
			};

			struct v2f
			{
				float2 uv : TEXCOORD0;
				float4 vertex : SV_POSITION;
			};

			v2f vert (appdata v)
			{
				v2f o;
				o.vertex = UnityObjectToClipPos(v.vertex);
				o.uv = v.uv;
				return o;
			}
			
			sampler2D _MainTex;
			float4 _MainTexTarget;
			float4 _MainTex_TexelSize;

			fixed4 frag (v2f i) : SV_Target
			{
				float2 modf = 3.375;//_MainTex_TexelSize.zw / float2(569,320);// / _MainTexTarget.xy;
				//fixed4 col = tex2D(_MainTex, (floor(i.uv * _MainTex_TexelSize.zw / modf + 0.5)*modf) / _MainTex_TexelSize.zw);
				fixed4 col = tex2D(_MainTex, i.uv);

				if(i.uv.x <= 0.5f)
				col.rgb = 0;
				// just invert the colors
				
				return col;
			}
			ENDCG
		}
	}
}
