﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour {

    public static GameManager GM;

    public GameObject AudioControllerObject;

    private AudioSource asc;

    void Awake()
    {
        if (GameManager.GM != null)
            GameObject.Destroy(gameObject);
        else
        {
            GM = this;

            DontDestroyOnLoad(this);
        }
    }

    private void Update()
    {
        if (GM == this)
        {
            if (Input.GetButtonDown("StartButton1"))
            {
                SceneManager.LoadScene(SceneManager.GetActiveScene().name);
            }
        }
    }

    private void Start()
    {
        if (GM == this)
        {
            asc = GetComponent<AudioSource>();
            asc.Play();
        }
    }

    // Use this for initialization
    public void playAudio(Vector3 position, AudioClip audio)
    {
        if (audio != null)
        {
            GameObject obj = Instantiate(AudioControllerObject, position, Quaternion.identity);
            obj.GetComponent<AudioSource>().clip = audio;
            obj.GetComponent<AudioSource>().Play();
        }
    }

    public void playAudio(Vector3 position, AudioClip audio, float volume)
    {
        if (audio != null)
        {
            GameObject obj = Instantiate(AudioControllerObject, position, Quaternion.identity);
            obj.GetComponent<AudioSource>().clip = audio;
            obj.GetComponent<AudioSource>().volume = volume;
            obj.GetComponent<AudioSource>().Play();
        }
    }

    public void playAudio(Vector3 position, AudioClip audio, float volume, float pitch)
    {
        if (audio != null)
        {
            GameObject obj = Instantiate(AudioControllerObject, position, Quaternion.identity);
            obj.GetComponent<AudioSource>().clip = audio;
            obj.GetComponent<AudioSource>().volume = volume;
            obj.GetComponent<AudioSource>().pitch = pitch;
            obj.GetComponent<AudioSource>().Play();
        }
    }

    public void playAudio(Vector3 position, AudioClip[] audio)
    {
        if (audio.Length > 0)
        {
        GameObject obj = Instantiate(AudioControllerObject, position, Quaternion.identity);
        obj.GetComponent<AudioSource>().clip = audio[(int)Random.Range(0f, audio.Length - 1)];
        obj.GetComponent<AudioSource>().Play();
        }
    }

    public void playAudio(Vector3 position, AudioClip[] audio, float volume)
    {
        if (audio.Length > 0)
        {
            GameObject obj = Instantiate(AudioControllerObject, position, Quaternion.identity);
            obj.GetComponent<AudioSource>().clip = audio[(int)Random.Range(0f, audio.Length - 1)];
            obj.GetComponent<AudioSource>().volume = volume;
            obj.GetComponent<AudioSource>().Play();
        }
    }

    public void playAudio(Vector3 position, AudioClip[] audio, float volume, float pitch)
    {
        if (audio.Length > 0)
        {
            GameObject obj = Instantiate(AudioControllerObject, position, Quaternion.identity);
            obj.GetComponent<AudioSource>().clip = audio[(int)Random.Range(0f, audio.Length - 1)];
            obj.GetComponent<AudioSource>().volume = volume;
            obj.GetComponent<AudioSource>().pitch = pitch;
            obj.GetComponent<AudioSource>().Play();
        }
    }

    public Vector3 approach_vec3(Vector3 current, Vector3 target, float step)
    {
        if (current.x < target.x)
            current.x = Mathf.Min(current.x + step, target.x);
        else
            current.x = Mathf.Max(current.x - step, target.x);

        if (current.y < target.y)
            current.y = Mathf.Min(current.y + step, target.y);
        else
            current.y = Mathf.Max(current.y - step, target.y);

        if (current.y < target.y)
            current.y = Mathf.Min(current.y + step, target.y);
        else
            current.y = Mathf.Max(current.y - step, target.y);

        return current;
    }
}
