﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class healthManager : MonoBehaviour
{
    public float[] hps;
    public string winscreen;
    public Image[] health;
    public GameObject[] victories;

    private GameObject[] players;

    public int[] wincount;

    public int loosers;
    public float fillamount;
    public bool shortpause;

    private Text countdown;
    private GameObject fight;
    private float sizer = 2;
    private float speed = 100;
    private float timer = 3.0f;
    private bool countround = true;
    private int fontsize;
    private int healthmax;
    private bool onceinalifetime;
    private Vector2 fightsize;
    private Text fighttext;
    private float scaling = 1;
    private bool doscale;
    private int round;
    private int winningplayer = -1;

    public GameObject gameOverObject;
    public bool gameOver = false;

    public AudioClip[] audioRoundAnnouncements;
    public AudioClip[] audioCounting;

    // Use this for initialization
    void Start()
    {
        round = 0;
        countdown = GetComponentInChildren<Text>();
        fontsize = countdown.fontSize;
        players = GameObject.FindGameObjectsWithTag("Player");
        healthmax = players[0].GetComponent<playerController>().health;
        fight = GameObject.Find("fight");
        fightsize = fight.transform.localScale;
        fighttext = fight.GetComponent<Text>();
        fight.SetActive(false);

        if (audioRoundAnnouncements.Length > round)
            GameManager.GM.playAudio(Vector3.zero, audioRoundAnnouncements[round]);
    }

    // Update is called once per frame
    void Update()
    {

        if (!gameOver)
        {
            if (doscale)
            {
                fight.transform.localScale = new Vector2(fight.transform.localScale.x + Time.deltaTime * scaling, fight.transform.localScale.y + Time.deltaTime * scaling);
                fighttext.color = new Color(fighttext.color.r, fighttext.color.g, fighttext.color.b, fighttext.color.a - Time.deltaTime * 1f);
                if (fighttext.color.a <= 0)
                {
                    fighttext.transform.localScale = fightsize;
                    doscale = false;
                    fighttext.color = new Color(fighttext.color.r, fighttext.color.g, fighttext.color.b, 1.0f);
                    fight.SetActive(false);
                }
            }
            for (int i = 0; i < hps.Length; i++)
            {
                if (wincount[i] > 2)
                {
                    dataHub.Winner = i;
                    Instantiate(gameOverObject);
                    gameOver = true;
                    //EditorSceneManager.LoadScene(winscreen);
                }
                if (wincount[i] > 0)
                {
                    Image[] chicks = victories[i].GetComponentsInChildren<Image>();
                    for (int z = 0; z < wincount[i]; z++)
                    {
                        chicks[z].enabled = true;
                    }
                }
                if (hps[i] > 0)
                {
                    if (health[i] != null)
                        health[i].fillAmount = hps[i] / healthmax;
                }
                if (hps[i] <= 0)
                {
                    if (health[i] != null)
                        health[i].fillAmount = 0;
                    loosers++;
                }
            }
            if (loosers < 3)
            {
                loosers = 0;
            }
            if (loosers >= 3)
            {
                for (int i = 0; i < hps.Length; i++)
                {
                    if (hps[i] > 0)
                    {
                        winningplayer = i;
                        GameOver(i);

                    }
                }
            }
        }
        else
        {
            transform.localScale = GameManager.GM.approach_vec3(transform.localScale, new Vector3(1f, 0f, 1f), 0.9f * Time.deltaTime);
            //transform.localScale = Vector3.Lerp(transform.localScale, new Vector3(1f, 0f, 1f), 0.999f * Time.deltaTime);
        }
    }

    private void GameOver(int playerwin)
    {
        shortpause = true;
        timer -= Time.deltaTime;
        string z = countdown.text;
        countdown.text = ((int)timer + 1).ToString();
        if(countdown.text != z)
            if (audioCounting.Length > round)
                GameManager.GM.playAudio(Vector3.zero, audioCounting[(int)timer]);
        //countdown.fontSize = ((int)(fontsize + Mathf.Lerp(-1.0f, 1.0f,Time.deltaTime)*speed));
        if (onceinalifetime)
        {
            countround = true;
            onceinalifetime = false;
        }
        if (timer <= 0)
        {
            Restart();
        }
        if (countround)
        {
            wincount[playerwin]++;
            countround = false;
        }
        return;
        
    }

    private void Restart()
    {
        shortpause = false;
        loosers = 0;
        timer = 3;
        onceinalifetime = true;
        fight.SetActive(true);
        doscale = true;

        round++;

        if(audioRoundAnnouncements.Length > round)
        GameManager.GM.playAudio(Vector3.zero, audioRoundAnnouncements[round]);

        for (int k = 0; k < players.Length; k++)
        {
            playerController playercon = players[k].GetComponent<playerController>();
            playercon.Reset();
            playercon.alive = true;
            playercon.state = "idle";
            playercon.health = 5;
        }
        countdown.text = "";
        return;

    }
}
