﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class playerController : MonoBehaviour {

	[Range(1, 4)]
	public int player;

    public float movespeed;
	public float deadzone;

    public string vertical1;
    public string horizontal1;
    public string dashr1;
    public string dashl1;
	public string weakAttack;
	public string heavyAttack;
    public bool alive = true;

	private Rigidbody2D rb2d;
	private Animator anim;
	

    //private string horizontal1;
    //private string vertical1;
  
	public string state = "idle";
	private float dodgeTimer = 0.125f;
	private float lightTimer = 0.125f;
	private float heavyTimer = 0.20f;
	private float damageTimer = 0.20f;
	public float timer = 0f;
    private Text winner;
    private int health = 3;
    private healthManager handlehealth;
    private int myplayer;
    private bool inspike;
    private bool inhazard;
    private Collider2D mycol;

    public GameObject bloodSplash;

    // Use this for initialization
    void Start () {
        mycol = gameObject.GetComponent<Collider2D>();
        rb2d = gameObject.GetComponent<Rigidbody2D>();
        anim = gameObject.GetComponent<Animator>();
        handlehealth = GameObject.Find("player health").GetComponent<healthManager>();
        myplayer = player - 1;
        handlehealth.hps[myplayer] = health;


    }
	
	// Update is called once per frame
	void Update () {
        if (!alive)
        {
            mycol.enabled = false;
            rb2d.velocity=new Vector2(0f,0f);
        }


        if (alive)
        {
            //health
            handlehealth.hps[myplayer] = health;


          
            //death
            if (health <= 0)
            {
                state = "death";
                anim.Play("death");
                alive = false;
                rb2d.velocity = Vector2.zero;
            }

            //stun timer
            if (timer != -1f)
            {
                timer -= Time.deltaTime;
                if (timer <= 0f)
                {
                    state = "idle";
                    anim.Play("idle");
                    timer = -1f;
                }
            }

            //decelerate
            if (state != "light" && state != "heavy" && state != "dodge" && state != "damage")
            {
                rb2d.velocity = rb2d.velocity - rb2d.velocity * 10 * Time.deltaTime;
            }

            //don't do anything when stunned
            if (timer <= 0f)
            {
                //attacks
                if (Input.GetButtonDown(heavyAttack))
                {
                    state = "heavy";
                    timer = heavyTimer;
                    rb2d.velocity = rb2d.transform.up * 20f;
                    if (Random.Range(0, 2) == 0)
                    {
                        anim.Play("punch_heavy_R");
                    }
                    else
                    {
                        anim.Play("punch_heavy_L");
                    }
                }

                if (Input.GetButtonDown(weakAttack))
                {
                    state = "light";
                    timer = lightTimer;
                    rb2d.velocity = rb2d.transform.up * 15f;
                    if (Random.Range(0, 2) == 0)
                    {
                        anim.Play("punch_light_R");
                    }
                    else
                    {
                        anim.Play("punch_light_L");
                    }
                }

                //dodge
                if (Input.GetButtonDown(dashl1))
                {
                    state = "dodge";
                    timer = dodgeTimer;
                    rb2d.velocity = rb2d.transform.right * -10f;
                    anim.Play("dodge_L");
                }

                if (Input.GetButtonDown(dashr1))
                {
                    state = "dodge";
                    timer = dodgeTimer;
                    rb2d.velocity = rb2d.transform.right * 10f;
                    anim.Play("dodge_R");
                }

                //accelerate
                if (state == "idle" || state == "run")
                {
                    Vector2 inp = new Vector2(Input.GetAxisRaw(horizontal1), Input.GetAxisRaw(vertical1));
                    if (inp.magnitude > deadzone && rb2d.velocity.magnitude <= movespeed)
                    {
                        if (inp.magnitude > 1.0f)
                        {
                            inp = inp.normalized;
                        }
                        transform.localRotation = Quaternion.AngleAxis(180 - Vector2.SignedAngle(Vector2.up, inp), transform.forward);
                        rb2d.velocity = new Vector2(movespeed * inp.x, -movespeed * inp.y);

                        state = "run";
                        anim.Play("run");
                    }

                    if (rb2d.velocity.magnitude < 0.25f)
                    {
                        rb2d.velocity = Vector2.zero;
                        state = "idle";
                        anim.Play("idle");
                    }
                }
            }

            //anim
            switch (state)
            {
                case "idle":
                    break;
            }
        }
		
	}

    void OnTriggerEnter2D(Collider2D coll){
		if (coll.gameObject.tag == "Spikes" && !inspike && alive) {
			if (coll.IsTouching(GetComponent<PolygonCollider2D>())) {
				coll.gameObject.GetComponent<SpikeControl> ().MakeBloody ();
				rb2d.velocity = coll.gameObject.transform.up * 5;
				Stun ();
                Damage();
                inspike = true;
			}
		}
        if (coll.gameObject.tag == "hazard" && !inhazard&& alive)
        {
            if (coll.IsTouching(GetComponent<PolygonCollider2D>()))
            {
                rb2d.velocity = gameObject.transform.up * -5;
                Stun();
                Damage();
                inhazard = true;
            }
        }
    }

	void OnTriggerStay2D(Collider2D coll){
		if (coll.gameObject.tag == "Player" && alive) {
			if (state == "heavy" || state == "light") {
				coll.gameObject.GetComponent<playerController> ().Stun ();
				//coll.gameObject.GetComponent<playerController> ().Stun (timer);
				coll.gameObject.GetComponent<Rigidbody2D> ().velocity = rb2d.velocity;
				rb2d.velocity = Vector2.zero;
				timer = 0;
				state = "idle";
			}
		}
	}
    
    void OnTriggerExit2D(Collider2D col)
    {
        if (col.gameObject.tag == "Spikes"&& alive)
        {
            inspike = false;
        }
        if (col.gameObject.tag == "hazard"&&alive)
        {
            inhazard = false;
        }
    }

	public void Stun(){
		Stun (damageTimer);

        GameObject cam = GameObject.Find("PixelCamera2D");
        cam.GetComponent<CameraFXController>().Screenshake(0.25f);
    }

	public void Stun(float seconds){
		state = "damage";
		timer = seconds;
		anim.Play ("damage");
       
	}

    private void Damage()
    {
        GameObject cam = GameObject.Find("PixelCamera2D");
        cam.GetComponent<CameraFXController>().Screenshake(0.3f+Random.Range(0f,0.1f));

        health--;
        Instantiate(bloodSplash, transform.position, Quaternion.Euler(transform.rotation.eulerAngles - new Vector3(0f, 0f, 90f)));
        if (health < 0)
        {
            health = 0;
        }
    }

  
}